unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, ExtCtrls, LCLProc, Buttons, Unit2, Unit3, Unit4, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
    procedure Button2Click(Sender: TObject);
    procedure Button2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  fi, fo : Text;
  arF : array[0..2000, 0..50000] of String;
  arE : array[0..2000] of Integer;
  i, j , lines, speed, nspeed : integer;
  Play , button2clicked, firstsettings: Boolean;
  Form1Color, Font1Color, FontSize : Integer;


implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.MenuItem1Click(Sender: TObject);
begin

end;

procedure TForm1.FormCreate(Sender: TObject);
var Png: TPortableNetworkGraphic;
begin
  i:=1;
  j:=0;
  Timer1.Enabled:=False;
  Png := TPortableNetworkGraphic.Create;
  try
    Png.LoadFromFile('play.png');
    BitBtn1.Glyph.Assign(Png);
  finally
    Png.Free;
  end;
  Play:=True;
  speed:=3;
  nspeed:=3;
  button2clicked:=true;
  firstsettings:=true;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Memo1.Height:=Form1.Height-117;
  Memo1.Width:=Form1.Width-20;
  Button1.Left:=Form1.Width-71;
  Button2.Left:=Form1.Width-129;
  Button1.Top:=Form1.Height-77;
  Button2.Top:=Form1.Height-77;
  BitBtn1.Top:=Form1.Height-77;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
   if key=VK_LEFT then begin
     Button2Click(Button2);
   end;
   if key=VK_RIGHT then begin
     Button1Click(Button1);
   end;
   key:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if not(button2clicked) then begin
    Memo1.Clear;
    Memo1.Append(' ');
    Memo1.Append(' ');
    Memo1.Append(' ');
    Memo1.Append(arF[i,j]);
   end;
   if j< arE[i] then Inc(j)
                else begin
                          Inc(i);
                          j:=0;
                          if i > lines then begin
                                                 i:=lines;
                                                 j:=arE[i];
                                             end;
                     end;
   if button2clicked then begin
     Memo1.Clear;
     Memo1.Append(' ');
     Memo1.Append(' ');
     Memo1.Append(' ');
     Memo1.Append(arF[i,j]);
   end;
end;

procedure TForm1.Button1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=VK_LEFT then begin
     Button2Click(Button2);
   end;
   if key=VK_RIGHT then begin
     Button1Click(Button1);
   end;
   key:=0;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if j > 0 then Dec(j)
           else begin
                  if i>1 then begin
                                   Dec(i);
                                   j:=arE[i];
                              end;
                end;
  Memo1.Clear;
  Memo1.Append(' ');
  Memo1.Append(' ');
  Memo1.Append(' ');
  Memo1.Append(arF[i,j]);
end;

procedure TForm1.Button2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_LEFT then begin
    Button2Click(Button2);
  end;
  if key=VK_RIGHT then begin
    Button1Click(Button1);
  end;
  key:=0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var Png: TPortableNetworkGraphic;
begin
  if Play then begin
    Timer1.Enabled:=True;
    Png := TPortableNetworkGraphic.Create;
    try
     Png.LoadFromFile('stop.png');
     BitBtn1.Glyph.Assign(Png);
    finally
     Png.Free;
    end;
  end   // if Play
  else begin
        Timer1.Enabled:=False;
        Png := TPortableNetworkGraphic.Create;
        try
         Png.LoadFromFile('play.png');
         BitBtn1.Glyph.Assign(Png);
        finally
         Png.Free;
        end;
  end;
  Play:=not(Play);
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
var ii, jj : integer;
    s, line : string;

begin
  OpenDialog1.Filter:='*.txt|*.txt';
  OpenDialog1.Title:='Open .txt file';
  if OpenDialog1.Execute then begin
     AssignFile(fi, OpenDialog1.FileName);
     reset(fi);
     ii:=0;
     jj:=0;
     s:='';
     while not(eof(fi)) do begin
       readln(fi, line);
       if UTF8Copy(line, 1, 3)='$$$' then begin
                                               Inc(ii);
                                               arE[ii-1]:=jj;
                                               jj:=0;
                                               arF[ii,jj]:=UTF8Copy(line, 4, UTF8Length(line)-3);
                                     end
                                     else begin
                                            Inc(jj);
                                            arF[ii,jj]:=line;
                                          end;
     end; // while not(eof(fi))
     arE[ii]:=jj;
     lines:=ii;
     CloseFile(fi);
     Form1.Memo1.Clear;
     Form1.Memo1.Append(' ');
     Form1.Memo1.Append(' ');
     Form1.Memo1.Append(' ');
     i:=1;
     j:=0;
     Form1.Memo1.Append(arF[i,j]);
     MenuItem6.Enabled:=True;
     Button1.Enabled:=True;
     Button2.Enabled:=True;
     BitBtn1.Enabled:=True;
  end; // if opendialog1.execute

end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  Halt;
end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  Form2.Show;
  if firstsettings then begin
    Form2.ColorBox1.ItemIndex:=15;
    Form2.ColorBox2.ItemIndex:=0;
    Form2.ComboBox1.ItemIndex:=4;
    Form2.ComboBox2.ItemIndex:=2;
    firstsettings:=false;
  end;
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
var k : integer;
begin
  Form3.Show;
  Form3.ListBox1.Clear;
  for k:=1 to lines do
   Form3.ListBox1.Items.Append(arF[k,0]);
  Form3.ListBox1.Selected[i-1]:=True;
  Form3.TrackBar1.Min:=0;
  Form3.TrackBar1.Max:=arE[Form3.ListBox1.ItemIndex+1];
  Form3.TrackBar1.Position:=j;
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  Form4.Show;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Dec(nspeed);
  if nspeed < 1 then begin
                       nspeed:=speed;
                       Button1Click(Button1);
                     end;
end;

end.

